#!/usr/bin/env python3

import pandas as ps
from bs4 import BeautifulSoup
import subprocess
from datetime import  date
from datetime import datetime, timedelta
BASE = 'https://www.fl.ru'

PROJECTS = []

# iterate over pages
page_no = 0
#date limitations
##enter the last day you want to grab. the first day will be month earlier
begindate = "04.12.2015"
enddate = datetime.strptime(begindate, "%d.%m.%Y")
startdate = enddate - timedelta(days=1000)


#if you want establish first day to collect, recomment 2 next strings
#startdate = "25.10.2016"
#startdate = datetime.strptime(startdate, "%d.%m.%Y") 


while True:
    page_no += 1
    # this is blocking
    subprocess.call(['phantomjs', 'grab_fl.js', BASE + '/projects/?page=%d' % page_no])
    page = open('/tmp/fl.html').read().strip()
    if page == "404":
        break
    projects_list = BeautifulSoup(page, 'html.parser')
    projects = projects_list.findAll('div', class_='b-post')
    # iterate over projects on a page
    for proj in projects:
        project_url = proj.find('a', class_='b-post__link')['href']
        project_id = project_url
        messages = proj.find("a", class_="b-post__link_color_0f71c8_hover")
        if messages:
            messages = messages.getText()
            if messages.split(' ')[0].isnumeric():
                project_answers = int(messages.split(' ')[0])
            else:
                project_answers = 0
        else:
            project_answers = ''
        project_title = proj.find('h2', class_="b-post__title").getText().strip()
        subprocess.call(['phantomjs', 'grab_fl.js', BASE + project_url])
        try:        
            project_page = open('/tmp/fl.html').read().strip()
            if project_page == "404":
                # what to do?
                continue
            # employer-name
            project = BeautifulSoup(project_page, 'html.parser')
            p = project.find('div', class_='b-layout_overflow_hidden')
        except IndexError:
            continue
        if p:
            project_published = p.find_all('div', class_="b-layout__txt_padbot_30")[-1].find_all('div')[-1].getText().strip().split('|')[0]
        else:
            p = project.find_all('div', class_='contest-body')[-1]
            project_published = list(project.find('div', class_="contest-e").strings)[-1].split('|')[0].replace('[', '').strip()
        project_description = p.find('div', class_="b-layout__txt b-layout__txt_padbot_20").getText().strip()
        requester = project.find('a', class_='employer-name')
        if requester:
            project_requester = requester['href']
        else:
            project_requester = ''
        finish = project.find('h1', class_='b-page__title')
        fineshed = finish.find('img', alt='Проект закрыт')
        if finished:
          project_finished=1
        else:
          project_finished=0
        project_category = ",".join(
            list(map(
                lambda x: x["href"].split('/')[2],
                filter(lambda x: 'freelancers' in x['href'], p.find_all('a'))
                
            ))
        )
        check_date = datetime.strptime(project_published.strip(), "%d.%m.%Y")
        age = enddate - check_date
        #if (check_date >= startdate and check_date <= enddate):
        if project_finished == 1:
            PROJECTS.append({
                'project_id': project_id,
                'published': project_published.strip(),
                'url': project_url,
                'title': project_title,
                'description': project_description,
                'category': project_category,
                'answers': project_answers,
                'requester': project_requester
                'finished': project_finished
                })
        else:
            #if project_published.strip() < startdate-timedelta(days=2):
            if age.days > 1:
                break
            pass
        
        # print('done %s' % project_id)
        # PROBABLY SHOULD INSERT TIMEOUT
        # OTHERWISE MIGHT BE BANNED
    print('Done page %d' % page_no)

    df = ps.DataFrame(PROJECTS)
    # SIMPLY REWRITE THE FILE EVERY TIME
    df.to_csv('fl_%s.csv' % str(date.today()), header=True, index=False, encoding='utf-8')
